module Paradoxo

abstract sig Pessoa {
	pai : lone Homem,
	mae : lone Mulher
}

sig Homem extends Pessoa {
	mulher : lone Mulher
}

sig Mulher extends Pessoa {
	marido : lone Homem
}

fact Biologia {
	no p : Pessoa | p in p.^(pai+mae)
}

fact Simetria {
	marido = ~mulher
}

fact ConvencaoSocial {
	let casado = marido+mulher, descendente = ^filho {
		// all x, y : Pessoa | x in y.casado => x !in y.descendente	
		no casado & descendente
	}	
}

run {}

fun filho : Pessoa -> Pessoa {
	~(pai+mae)
	// {x, y : Pessoa | x in y.(pai+mae)}
}

pred MaisBiologia {
	no p : Pessoa | p in p.^filho
}

pred MaisBiologia' {
	no ^filho & iden
}

check {MaisBiologia <=> MaisBiologia'} for 5

fun avo : Pessoa -> Pessoa {
	let ascendente = pai + mae + pai.mulher + mae.marido {
		ascendente.ascendente
	}
}

assert NinguemEAvoDeleProprio {
	no p : Pessoa | p in p.avo
}

check NinguemEAvoDeleProprio for 4
